=begin
#Harbor API

#These APIs provide services for manipulating Harbor project.

OpenAPI spec version: 2.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.17

=end

require 'date'

module Harbor2LegacyClient
  # The replication execution
  class ReplicationExecution
    # The ID
    attr_accessor :id

    # The policy ID
    attr_accessor :policy_id

    # The status
    attr_accessor :status

    # The status text
    attr_accessor :status_text

    # The trigger mode
    attr_accessor :trigger

    # The total count of all tasks
    attr_accessor :total

    # The count of failed tasks
    attr_accessor :failed

    # The count of succeed tasks
    attr_accessor :succeed

    # The count of in_progress tasks
    attr_accessor :in_progress

    # The count of stopped tasks
    attr_accessor :stopped

    # The start time
    attr_accessor :start_time

    # The end time
    attr_accessor :end_time

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'id' => :'id',
        :'policy_id' => :'policy_id',
        :'status' => :'status',
        :'status_text' => :'status_text',
        :'trigger' => :'trigger',
        :'total' => :'total',
        :'failed' => :'failed',
        :'succeed' => :'succeed',
        :'in_progress' => :'in_progress',
        :'stopped' => :'stopped',
        :'start_time' => :'start_time',
        :'end_time' => :'end_time'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'id' => :'Integer',
        :'policy_id' => :'Integer',
        :'status' => :'String',
        :'status_text' => :'String',
        :'trigger' => :'String',
        :'total' => :'Integer',
        :'failed' => :'Integer',
        :'succeed' => :'Integer',
        :'in_progress' => :'Integer',
        :'stopped' => :'Integer',
        :'start_time' => :'String',
        :'end_time' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'policy_id')
        self.policy_id = attributes[:'policy_id']
      end

      if attributes.has_key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.has_key?(:'status_text')
        self.status_text = attributes[:'status_text']
      end

      if attributes.has_key?(:'trigger')
        self.trigger = attributes[:'trigger']
      end

      if attributes.has_key?(:'total')
        self.total = attributes[:'total']
      end

      if attributes.has_key?(:'failed')
        self.failed = attributes[:'failed']
      end

      if attributes.has_key?(:'succeed')
        self.succeed = attributes[:'succeed']
      end

      if attributes.has_key?(:'in_progress')
        self.in_progress = attributes[:'in_progress']
      end

      if attributes.has_key?(:'stopped')
        self.stopped = attributes[:'stopped']
      end

      if attributes.has_key?(:'start_time')
        self.start_time = attributes[:'start_time']
      end

      if attributes.has_key?(:'end_time')
        self.end_time = attributes[:'end_time']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          policy_id == o.policy_id &&
          status == o.status &&
          status_text == o.status_text &&
          trigger == o.trigger &&
          total == o.total &&
          failed == o.failed &&
          succeed == o.succeed &&
          in_progress == o.in_progress &&
          stopped == o.stopped &&
          start_time == o.start_time &&
          end_time == o.end_time
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, policy_id, status, status_text, trigger, total, failed, succeed, in_progress, stopped, start_time, end_time].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Harbor2LegacyClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
